(window.webpackJsonp=window.webpackJsonp||[]).push([[169],{"./version-control/diff/constants.ts":function(e,t,s){"use strict";s.r(t),s.d(t,"ENABLE_DIFF_MERGE_V2_FLAG",(function(){return o})),s.d(t,"DiffVersion",(function(){return r}));const o={key:"enable-diff-merge-v2",defaultValue:!1},r={V1:"v1",V2:"v2"}},"./version-control/pull-request/components/PullRequestListing/emptyState.tsx":function(e,t,s){"use strict";s.r(t),s.d(t,"default",(function(){return l}));var o=s("../../node_modules/react/index.js"),r=s.n(o),n=s("../../node_modules/@postman/aether/esmLib/index.js");function l(e){return r.a.createElement(n.BlankState,{title:e.title,description:e.message},e.illustration)}},"./version-control/pull-request/components/PullRequestListing/index.ts":function(e,t,s){"use strict";s.r(t);var o=s("./version-control/pull-request/components/PullRequestListing/modelPullRequests.tsx"),r=s("./version-control/pull-request/components/PullRequestListing/emptyState.tsx");s.d(t,"EmptyState",(function(){return r.default}));var n=s("./version-control/pull-request/components/PullRequestListing/usePullRequests.ts");s.d(t,"usePullRequests",(function(){return n.default})),t.default=o.default},"./version-control/pull-request/components/PullRequestListing/modelPullRequests.tsx":function(e,t,s){"use strict";s.r(t),s.d(t,"default",(function(){return b}));var o=s("../../node_modules/react/index.js"),r=s.n(o),n=s("../../node_modules/styled-components/dist/styled-components.browser.esm.js"),l=s("../../node_modules/@postman/aether/esmLib/index.js"),u=s("./node_modules/lodash/lodash.js"),i=s.n(u),a=s("./js/components/base/LoadingIndicator.js"),c=s("./appsdk/contextbar/ContextBarViewHeader.js"),d=s("./version-control/pull-request/hooks/usePullRequestMergeSettingsViewPermission.js"),m=s("./js/services/NavigationService.js"),p=s("./version-control/pull-request/components/PullRequestListing/emptyState.tsx"),f=s("./version-control/pull-request/components/PullRequestListing/usePullRequests.ts"),g=s("./version-control/hooks/useConnectionStatus.ts"),v=s("./version-control/pull-request/components/PullRequestListing/pullRequesFilter.tsx"),h=s("./version-control/pull-request/components/PullRequestListing/pullRequestList.tsx"),q=s("./version-control/pull-request/config/index.ts");const y=n.default.div`
  display: flex;
  flex-direction: column;
  height: 100%;

  .pullRequest-content-container {
    padding-left: ${({theme:e})=>e["spacing-s"]};
    padding-right: ${({theme:e})=>e["spacing-xxl"]};
    padding-bottom: ${({theme:e})=>e["spacing-m"]};
    flex: auto;
    overflow: auto;
    display: flex;
    flex-direction: column;
  }

  .pullRequest-list-container {
    flex: auto;
    overflow: auto;
    display: flex;
    flex-direction: column;
  }
`;function b(e){const[t,s]=Object(o.useState)({open:!0,approved:!0,merged:!0,declined:!0}),n=Object(g.default)(),{pullRequests:u,error:b,isLoading:j,filteredPullRequests:P}=Object(f.default)({model:e.contextData.model,modelId:e.contextData.uid,filters:t,retryOnConnection:!0}),E=!(null==u?void 0:u.length),R=!(null==P?void 0:P.length),{permission:I}=Object(d.default)(e.contextData.model,e.contextData.uid),w=i.a.get(q.default,`${e.contextData.model}.displayName`,"");return n||u?r.a.createElement(y,null,r.a.createElement(c.ContextBarViewHeader,{title:"Pull requests",onClose:e.onClose},r.a.createElement("div",{className:"pull-request-container__actions-filter"},I&&r.a.createElement(l.Button,{type:"tertiary",icon:"icon-descriptive-setting-stroke",onClick:()=>{m.default.transitionTo("build.roles.manage",{},{collection:e.contextData.uid})},tooltip:"View merge settings"}),r.a.createElement(v.default,{filters:t,onChange:s,disabled:E}))),r.a.createElement("div",{className:"pullRequest-content-container"},r.a.createElement(l.Text,{type:"body-medium",color:"content-color-secondary"},"Keep track of all pull requests for this ",w,"."),r.a.createElement("div",{className:"pullRequest-list-container"},r.a.createElement(o.Fragment,null,j&&r.a.createElement("div",{className:"collection-info-cb__pull-requests-loading"},r.a.createElement(a.default,null)),b&&!j&&r.a.createElement(p.default,{illustration:r.a.createElement(l.IllustrationInternalServerError,null),title:"Unable to load pull requests",message:"Please try refetching pull requests."}),!b&&!j&&E&&r.a.createElement(p.default,{illustration:r.a.createElement(l.IllustrationNoPullRequest,null),title:"No pull requests right now",message:`View and keep track of all the pull requests on this ${w}.`}),!b&&!j&&!E&&R&&r.a.createElement(p.default,{illustration:r.a.createElement(l.IllustrationNoPullRequest,null),title:"No pull requests found",message:"Change filters and try again."}),!b&&!E&&P&&r.a.createElement(h.default,{pullRequests:P}))))):r.a.createElement(y,null,r.a.createElement(c.ContextBarViewHeader,{title:"Pull requests",onClose:e.onClose}),r.a.createElement(o.Fragment,null,r.a.createElement(p.default,{illustration:r.a.createElement(l.IllustrationCheckInternetConnection,null),title:"Check your connection",message:"Get online to view your list of Pull Requests"})))}},"./version-control/pull-request/components/PullRequestListing/pullRequesFilter.tsx":function(e,t,s){"use strict";s.r(t),s.d(t,"default",(function(){return c}));var o=s("../../node_modules/react/index.js"),r=s.n(o),n=s("../../node_modules/@postman/aether/esmLib/index.js"),l=s("../../node_modules/styled-components/dist/styled-components.browser.esm.js"),u=s("./js/components/base/Tooltips.js");const i=l.createGlobalStyle`
  .pullRequest-status-filter__option {
    margin-top: ${({theme:e})=>e["spacing-m"]};
  }

  .pullRequest-status-filer-popover .tooltip-wrapper {
    padding: ${({theme:e})=>e["spacing-m"]};
    background-color: ${({theme:e})=>e["background-color-primary"]};
  }
`,a=[{label:"Open requests",value:"open"},{label:"Approved requests",value:"approved"},{label:"Merged requests",value:"merged"},{label:"Declined requests",value:"declined"}];function c(e){const[t,s]=Object(o.useState)(!1),[l,c]=Object(o.useState)(),{filters:d,onChange:m,disabled:p}=e;return r.a.createElement(o.Fragment,null,r.a.createElement(i,null),r.a.createElement(n.Button,{type:"tertiary",icon:"icon-action-filter-stroke",onClick:()=>{s(!t)},ref:c,isDisabled:p,tooltip:"Filter pull requests"}),l&&r.a.createElement(u.Tooltip,{show:t,target:l,onClose:()=>s(!1),closeOnClickOutside:!0,immediate:!0,hideArrow:!0,placement:"bottom-right",className:"pullRequest-status-filer-popover"},r.a.createElement(u.TooltipBody,null,r.a.createElement(n.Label,{type:"primary",size:"medium",text:"Show"}),r.a.createElement("div",null,a.map((e=>r.a.createElement(n.Checkbox,{className:"pullRequest-status-filter__option",key:e.value,label:e.label,isChecked:d[e.value],onChange:()=>m(Object.assign(Object.assign({},d),{[e.value]:!d[e.value]}))})))))))}},"./version-control/pull-request/components/PullRequestListing/pullRequestList.tsx":function(e,t,s){"use strict";s.r(t);var o=s("./node_modules/moment/moment.js"),r=s.n(o),n=s("../../node_modules/react/index.js"),l=s("../../node_modules/styled-components/dist/styled-components.browser.esm.js"),u=s("../../node_modules/@postman/aether/esmLib/index.js"),i=s("./node_modules/lodash/lodash.js"),a=s.n(i),c=s("./js/stores/ActiveWorkspaceStore.js"),d=s("./js/stores/StoreManager.js"),m=s("./appsdk/components/link/Link.js"),p=s("./js/components/base/Avatar.js"),f=s("./version-control/common/index.js");const g={open:"neutral",approved:"warning",merged:"success",declined:"critical"},v=l.default.li`
  all: unset;
  display: flex;
  align-items: center;
  width: 100%;
  margin-top: ${({theme:e})=>e["spacing-m"]};

  .title-group {
    width: 50%;
    display: inline-flex;
    flex-direction: column;
    color: ${({theme:e})=>e["content-color-primary"]};
  }

  .avatar-container {
    width: 25%;
    display: flex;
    justify-content: center;
  }

  .status-container {
    width: 25%;
    display: flex;
    justify-content: flex-end;
  }

  .pullRequest-list-item__title {
    font-size: ${({theme:e})=>e["text-size-m"]};
    line-height: ${({theme:e})=>e["line-height-m"]};
    /** link type text sets max-content width which results in no wrapping */
    width: unset;
    display: inline-block;
  }
`;function h({pullRequest:e}){return n.createElement(v,null,n.createElement("div",{className:"title-group"},n.createElement("div",{className:"title"},n.createElement(m.default,{to:{routeIdentifier:"build.pullRequestView",routeParams:{id:e.id},queryParams:{workspace:Object(d.resolveStoreInstance)(c.default).id}}},n.createElement(u.Text,{type:"link-subtle",className:"pullRequest-list-item__title"},e.title))),n.createElement(u.Text,{type:"body-small",color:"content-color-tertiary"},"Last updated: ",r()(e.updatedAt).fromNow())),n.createElement("div",{className:"avatar-container"},n.createElement(f.CustomTooltip,{align:"bottom",body:a.a.get(e,"createdBy.name")},n.createElement(p.default,{className:"pr-author-avatar",size:"medium",userId:a.a.get(e,"createdBy.id",0),customPic:a.a.get(e,"createdBy.profilePicUrl")}))),n.createElement("div",{className:"status-container"},n.createElement(u.Badge,{text:e.status,status:g[e.status]})))}const q=l.default.ul`
  all: unset;
`;t.default=function(e){const{pullRequests:t}=e;return n.createElement(q,null,t.map((e=>n.createElement(h,{key:e.id,pullRequest:e}))))}},"./version-control/pull-request/components/PullRequestListing/usePullRequests.ts":function(e,t,s){"use strict";s.r(t),s.d(t,"default",(function(){return i}));var o=s("../../node_modules/react/index.js"),r=s("./node_modules/lodash/lodash.js"),n=s.n(r),l=s("./version-control/pull-request/services/PullRequestService.js"),u=s("./version-control/hooks/useConnectionStatus.ts");function i(e){const[t,s]=Object(o.useState)(!1),[r,i]=Object(o.useState)(),[a,c]=Object(o.useState)(),d=Object(u.default)();let m;const p=()=>{s(!0),Object(l.fetchPullRequests)(e.model,e.modelId).then((e=>{i(n()(e.pullRequests).sortBy("updatedAt").reverse().value())})).catch((e=>{c(e)})).finally((()=>{s(!1)}))};if(Object(o.useEffect)((()=>{d&&p()}),[]),Object(o.useEffect)((()=>{d&&e.retryOnConnection&&!t&&!r&&p()}),[d]),r)if(e.filters){const t=Object.keys(e.filters).filter((t=>e.filters&&e.filters[t]));m=r.filter((e=>t.includes(e.status)))}else m=r;return{pullRequests:r,filteredPullRequests:m,isLoading:t,error:a,fetch:p}}},"./version-control/pull-request/config/collection.ts":function(e,t,s){"use strict";s.r(t);t.default={displayName:"collection",permissions:{viewMergeSettings:({modelId:e,userId:t})=>({entityType:"user",entityId:t,permission:"VIEW_PULL_REQUEST_SETTINGS",objectType:"collection",objectId:e}),viewModel:"VIEW_COLLECTION",editModel:"UPDATE_COLLECTION"}}},"./version-control/pull-request/config/environment.ts":function(e,t,s){"use strict";s.r(t);t.default={displayName:"environment",permissions:{viewMergeSettings:({modelId:e,userId:t})=>({entityType:"user",entityId:t,permission:"VIEW_PULL_REQUEST_SETTINGS",objectType:"environment",objectId:e}),viewModel:"VIEW_ENVIRONMENT",editModel:"UPDATE_ENVIRONMENT"}}},"./version-control/pull-request/config/index.ts":function(e,t,s){"use strict";s.r(t);var o=s("./version-control/pull-request/config/collection.ts"),r=s("./version-control/pull-request/config/environment.ts");const n={collection:o.default,environment:r.default};t.default=n},"./version-control/pull-request/hooks/usePullRequestMergeSettingsViewPermission.js":function(e,t,s){"use strict";s.r(t),s.d(t,"default",(function(){return u}));var o=s("../../node_modules/react/index.js"),r=s("./version-control/pull-request/services/PullRequestService.js"),n=s("./js/stores/CurrentUserStore.js"),l=s("./js/stores/StoreManager.js");function u(e,t){const[s,u]=Object(o.useState)(!1),[i,a]=Object(o.useState)(),[c,d]=Object(o.useState)(),m=Object(o.useRef)(),p=Object(l.resolveStoreInstance)(n.default).id;return Object(o.useEffect)((()=>(m.current=!0,(async()=>{try{m.current&&u(!0);const s=await Object(r.checkPullRequestMergeSettingViewPermission)({model:e,modelId:t,userId:p});m.current&&a(s)}catch(e){m.current&&d(e.error||e)}finally{m.current&&u(!1)}})(),()=>{m.current=!1})),[]),{isLoading:s,permission:i,error:c}}},"./version-control/pull-request/services/PullRequestService.js":function(e,t,s){"use strict";s.r(t),s.d(t,"fetchPullRequest",(function(){return p})),s.d(t,"fetchPullRequests",(function(){return f})),s.d(t,"fetchPullRequestSettings",(function(){return g})),s.d(t,"fetchPullRequestDiff",(function(){return v})),s.d(t,"fetchDiff",(function(){return h})),s.d(t,"fetchMergeStrategies",(function(){return q})),s.d(t,"createPullRequest",(function(){return y})),s.d(t,"updatePullRequest",(function(){return b})),s.d(t,"mergePullRequest",(function(){return j})),s.d(t,"declinePullRequest",(function(){return P})),s.d(t,"approvePullRequest",(function(){return E})),s.d(t,"unapprovePullRequest",(function(){return R})),s.d(t,"fetchCollectionRoles",(function(){return I})),s.d(t,"fetchModelPermissions",(function(){return w})),s.d(t,"isPublicCollection",(function(){return x})),s.d(t,"fetchSuggestedReviewers",(function(){return _})),s.d(t,"updateEntityPullRequestSettings",(function(){return S})),s.d(t,"fetchEntityPullRequestSettings",(function(){return L})),s.d(t,"checkPullRequestMergeSettingViewPermission",(function(){return C})),s.d(t,"getPullRequestCommentingPermissions",(function(){return O}));var o=s("./node_modules/lodash/lodash.js"),r=s.n(o),n=s("./node_modules/querystring-browser/querystring.js"),l=s.n(n),u=s("./js/modules/services/RemoteSyncRequestService.js"),i=s("./js/stores/CurrentUserStore.js"),a=s("./js/stores/StoreManager.js"),c=s("./version-control/pull-request/config/index.ts"),d=s("./onboarding/src/common/LaunchDarkly.js"),m=s("./version-control/diff/constants.ts");function p(e,t){const s=t?{populateUsers:t}:{};let o=r.a.isEmpty(s)?`/v1/pull-requests/${e}`:`/v1/pull-requests/${e}?${l.a.stringify(s)}`;return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:o}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject({message:"Something went wrong while fetching the pull request."})))}function f(e,t){const s={entity:e,toId:t,populateUsers:!0};return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-requests?${l.a.stringify(s)}`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function g(e){const t={entity:"collection",entityId:e,mergers:!0,populateUsers:!0};if(e)return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-request-settings?${l.a.stringify(t)}`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)));pm.logger.error("PullRequestService~fetchPullRequestSettings: No object id specified to fetch pull request settings")}function v(e){return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-requests/${e}/diff?navigation=true`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function h(e,t){if(e&&t)return u.default.request(`/collection/diff/${e}?source=${t}&navigation=true`,{method:"get"}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function q(e){const t=d.launchDarkly.getFlag(m.ENABLE_DIFF_MERGE_V2_FLAG.key,m.ENABLE_DIFF_MERGE_V2_FLAG.defaultValue);return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-requests/${e}/merge-strategies?diffVersion=${t?"2.0.0":"1.0.0"}`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function y(e){return Object(a.resolveStoreInstance)(i.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to create pull request"}),u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"post",path:"/v1/pull-requests",body:e}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function b(e,t){return Object(a.resolveStoreInstance)(i.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to update pull request"}),u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}`,body:t}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function j(e,t){Object(a.resolveStoreInstance)(i.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to merge pull request"});const s=d.launchDarkly.getFlag(m.ENABLE_DIFF_MERGE_V2_FLAG.key,m.ENABLE_DIFF_MERGE_V2_FLAG.defaultValue),o=t?{mergeStrategy:t}:{};return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/merge?diffVersion=${s?"2.0.0":"1.0.0"}`,body:o}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function P(e,t,s){return Object(a.resolveStoreInstance)(i.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to decline pull request"}),u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/decline?diffVersion=${t}`,body:{comment:s}}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function E(e){return Object(a.resolveStoreInstance)(i.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to approve pull request"}),u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/approve`,body:{}}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function R(e){return Object(a.resolveStoreInstance)(i.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to unapprove pull request"}),u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/unapprove`,body:{}}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function I(e){return u.default.request(`/collection/roles/${e}`,{method:"get"}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function w(e,t,s){return u.default.request("/ws/proxy",{method:"post",data:{service:"acs",method:"get",path:`/api/v1/entities?filter.objectType=${e}&filter.objectId=${t}&filter.permission=${s}&filter.entityTypes=user,group,team`}}).then((({body:e})=>e)).catch((({error:e})=>Promise.reject(e)))}function x(e){let t={};return(e||[]).forEach((e=>{t[e]={entityType:"group",entityId:"anybody",permission:"VIEW_COLLECTION",objectType:"collection",objectId:e}})),u.default.request("/ws/proxy",{method:"post",data:{service:"acs",method:"post",path:"/api/permissions/check",body:{checks:t}}}).then((({body:e})=>Promise.resolve(e))).catch((e=>Promise.resolve(e)))}function _(e,t){return e&&t||pm.toasts.error("Entity and Entity Id are required parameters",{noIcon:!0,title:"Invalid params"}),u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/reviewer-suggestions?entity=${e}&entityId=${t}`}}).then((({body:e})=>Promise.resolve(e))).catch((e=>Promise.resolve(e)))}async function S(e,t,s){if("collection"===e)return async function(e,t){return t?u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"post",body:{settings:e},path:`/v1/pull-request-settings?entity=collection&entityId=${t}&mergers=true&populateUsers=true`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e))):(pm.logger.error("PullRequestService~updatePullRequestSettings: entityId is a mandatory parameter"),Promise.reject(new Error("Something went wrong while updating pull request settings.")))}(s,t)}async function L(e,t){if("collection"===e){let{settings:e}=await async function(e){if(e)return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",body:{},path:`/v1/pull-request-settings?entity=collection&entityId=${e}&mergers=true&populateUsers=true`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)));pm.logger.error("PullRequestService~fetchPullRequestSettings: No object id specified to fetch pull request settings")}(t);return{settings:e}}}function C({model:e,modelId:t,userId:s}){const o=r.a.get(c.default,`${e}.permissions.viewMergeSettings`);let n;return o&&(n=o({modelId:t,userId:s})),u.default.request("/ws/proxy",{method:"post",data:{service:"acs",method:"post",path:"/api/permissions/check",body:{checks:{prMergeSettingsView:n}}}}).then((({body:e})=>{const{results:t}=e;return r.a.get(t,"prMergeSettingsView.allowed",!1)}))}function O({prId:e,userId:t,destinationId:s}){return u.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"post",path:"/v1/permissions/check?checkModelOrParent=true",body:{checks:{addComment:{entityType:"user",entityId:t,permission:"ADD_COMMENT_ON_PULL_REQUEST",objectType:"pullRequest",objectId:e},resolveComment:{entityType:"user",entityId:t,permission:"RESOLVE_COMMENT_ON_PULL_REQUEST",objectType:"pullRequest",objectId:e},deleteComment:{entityType:"user",entityId:t,permission:"DELETE_COMMENT_ON_PULL_REQUEST",objectType:"pullRequest",objectId:e}}}}}).then((({body:e})=>{const{results:t}=e;return{addComment:r.a.get(t,"addComment.allowed"),resolveComment:r.a.get(t,"resolveComment.allowed"),deleteComment:r.a.get(t,"deleteComment.allowed")}})).catch((e=>({addComment:!1,resolveComment:!1,deleteComment:!1})))}}}]);